package com.engine.workflow.cmd.forward;

import com.api.browser.bean.SearchConditionItem;
import com.api.browser.bean.SearchConditionOption;
import com.api.browser.util.ConditionType;
import com.api.hrm.bean.HrmFieldBean;
import com.api.hrm.bean.SelectOption;
import com.api.hrm.bean.WeaRadioGroup;
import com.api.hrm.util.HrmFieldSearchConditionComInfo;
import com.engine.core.interceptor.AbstractCommand;
import com.engine.core.interceptor.CommandContext;
import com.engine.workflow.biz.freeNode.FreeNodeBiz;
import com.engine.workflow.util.AuthorityUtil;
import weaver.conn.RecordSet;
import weaver.general.Util;
import weaver.hrm.User;
import weaver.hrm.moduledetach.ManageDetachComInfo;
import weaver.systeminfo.SystemEnv;
import weaver.workflow.workflow.WfFwLimitUtil;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class GetFwLimitBrowserCmd extends AbstractCommand<Map<String, Object>> {

    public GetFwLimitBrowserCmd(User user, Map<String, Object> params) {
        this.user = user;
        this.params = params;
    }

    @Override
    public Map<String, Object> execute(CommandContext commandContext) {
        Map<String, Object> apidatas = new HashMap<String,Object>();
        String type = Util.null2String(params.get("type"));
        int wfid = Util.getIntValue(Util.null2String(params.get("wfid")),0);
        if(!"canChoiceOperator".equals(type)){
            int operatelevel = AuthorityUtil.getWorkflowUserRight(user, wfid);
            if (operatelevel < 0) {
                apidatas.put("operatelevel", operatelevel);
                return apidatas;
            }
        }
        if("weaAuth".equals(type)){ //添加范围
            apidatas = getWeaAuthData(params,user);
        }else if("baseSet".equals(type)){//基础数据、数据列表
            WfFwLimitUtil wfFwLimitUtil = new WfFwLimitUtil();
            apidatas = wfFwLimitUtil.getBaseSetData(params,user);
        }else if("advanceList".equals(type)){
            WfFwLimitUtil wfFwLimitUtil = new WfFwLimitUtil();
            apidatas = wfFwLimitUtil.getAdvanceData(params,user);//高级模式下的 操作者、接收人范围列表
        }else if("canChoiceOperator".equals(type)){
            apidatas = canChoiceOperator(params,user);//允许选择节点参与人 作为 转发对象、意见征询对象
        }
        return apidatas;
    }

    public Map<String, Object> canChoiceOperator(Map<String, Object> params,User user){
        Map<String, Object> apidatas = new HashMap<String,Object>();
        int wfid = Util.getIntValue(Util.null2String(params.get("wfid")),0);
        int nodeid = Util.getIntValue(Util.null2String(params.get("nodeid")),0);
        nodeid = FreeNodeBiz.getExtendNodeId(nodeid);
        String fwtype = Util.null2String(Util.null2String(params.get("fwtype"))); // 1、转发，2、意见征询，3、转办
        //征询转办取意见征询设置
        if ("5".equals(fwtype)) {
            fwtype = "2";
        }
        String isopen = "0";
        String choiceoperator = "0";
        RecordSet rs = new RecordSet();
        String sql = "select isopen,choiceoperator from workflow_FwLimitSet where fwtype='"+fwtype+"' and nodeid="+nodeid;
        if(wfid>0){
            sql += " and wfid="+wfid;
        }
        rs.execute(sql);
        if(rs.next()){
            isopen = rs.getString("isopen");
            choiceoperator = rs.getString("choiceoperator");
        }
        apidatas.put("isopen", isopen);
        apidatas.put("choiceoperator", choiceoperator);
        apidatas.put("success", "1");
        return apidatas;
    }

    /**
     * 操作者、接收人范围 卡片数据
     * @return
     */
    public Map<String, Object> getWeaAuthData(Map<String, Object> params,User user){
        Map<String, Object> apidatas = new HashMap<String,Object>();

        int wfid = Util.getIntValue(Util.null2String(params.get("wfid")),0);
        int nodeid = Util.getIntValue(Util.null2String(params.get("nodeid")),0);
        nodeid = FreeNodeBiz.getExtendNodeId(nodeid);
        String fwtype = Util.null2String(Util.null2String(params.get("fwtype"))); // 1、转发，2、意见征询，3、转办

        String modetype = Util.null2String(params.get("modetype")); //0:普通模式 1：高级模式
        int tabid = Util.getIntValue(Util.null2String(params.get("tabid")),0); //0:添加操作者  1：添加接收人范围
        int mainid = Util.getIntValue(Util.null2String(params.get("mainid")),0); //高级模式-主ID

        //Map<String,Object> groupitem = null;
        List<Object> itemlist = null;

        //供前台发送请求传递用
        Map<String,Object> hiddenMap = new HashMap<String,Object>();
        hiddenMap.put("wfid",wfid);
        hiddenMap.put("nodeid",nodeid);
        hiddenMap.put("fwtype",fwtype);
        hiddenMap.put("modetype",modetype);
        hiddenMap.put("tabid",tabid);
        hiddenMap.put("mainid",mainid);

        try {
            int objtype_labelid = (tabid==0&&"1".equals(modetype))?130470:386135; //操作者类型、接收人类型
            int relationship_labelid = ("1".equals(modetype) && tabid==0)?15364:386136; //条件、范围关系
            boolean isAdvanceOper = ("1".equals(modetype) && tabid==0);

            //接收人类型、内容、级别
            String[] fields = new String[]{"objtype,"+objtype_labelid+",5,1","userid,345,3,17","subids,345,3,194","departmentid,345,3,57",
                    "roleid,345,3,65",
                    "jobid,345,3,278","joblevel,28169,5,1","jobtitlesubcompany,19437,3,194","jobtitledepartment,19438,3,57",
                    "seclevel,683,1,scope","rolelevel,383129,5,1","relationship,"+relationship_labelid+",5,1"};
            HrmFieldSearchConditionComInfo hrmFieldSearchConditionComInfo = new HrmFieldSearchConditionComInfo();
            SearchConditionItem searchConditionItem = null;
            HrmFieldBean hrmFieldBean = null;
            itemlist = new ArrayList<Object>();
            //groupitem = new HashMap<String,Object>();
            //groupitem.put("title", "添加操作者");
            //groupitem.put("defaultshow", true);

            for(int i=0;i<fields.length;i++) {
                String[] fieldinfo = fields[i].split(",");
                hrmFieldBean = new HrmFieldBean();
                hrmFieldBean.setFieldname(fieldinfo[0]);
                hrmFieldBean.setFieldlabel(fieldinfo[1]);
                hrmFieldBean.setFieldhtmltype(fieldinfo[2]);
                hrmFieldBean.setType(fieldinfo[3]);
                if (hrmFieldBean.getType().equals("scope")) {
                    hrmFieldBean.setIsScope(true);
                }
                hrmFieldBean.setIsFormField(true);
                searchConditionItem = hrmFieldSearchConditionComInfo.getSearchConditionItem(hrmFieldBean, user);

                if(hrmFieldBean.getFieldhtmltype().equals("5")){
                    List<SearchConditionOption> statusOptions = new ArrayList<SearchConditionOption>();
                    if(hrmFieldBean.getFieldname().equals("objtype")){
                        statusOptions = getObjTypeOption(user,tabid);
                        searchConditionItem.setOptions(statusOptions);
                    }else if(hrmFieldBean.getFieldname().equals("rolelevel")){
                        statusOptions.add(new SearchConditionOption("0", SystemEnv.getHtmlLabelName(124,user.getLanguage())));
                        statusOptions.add(new SearchConditionOption("1", SystemEnv.getHtmlLabelName(141,user.getLanguage())));
                        statusOptions.add(new SearchConditionOption("2", SystemEnv.getHtmlLabelName(140,user.getLanguage()),true));
                        searchConditionItem.setOptions(statusOptions);
                    }else if(hrmFieldBean.getFieldname().equals("joblevel")){
                        statusOptions.add(new SearchConditionOption("2", SystemEnv.getHtmlLabelName(140,user.getLanguage())));
                        statusOptions.add(new SearchConditionOption("0", SystemEnv.getHtmlLabelName(19438, Util.getIntValue(user.getLanguage())),true));
                        statusOptions.add(new SearchConditionOption("1", SystemEnv.getHtmlLabelName(19437, Util.getIntValue(user.getLanguage()))));
                        searchConditionItem.setOptions(statusOptions);
                    }else if(hrmFieldBean.getFieldname().equals("relationship")){
                        statusOptions.add(new SearchConditionOption("0", SystemEnv.getHtmlLabelName(346,user.getLanguage()),true));
                        statusOptions.add(new SearchConditionOption("1", SystemEnv.getHtmlLabelName(386080,user.getLanguage())));
                        searchConditionItem.setOptions(statusOptions);
                    }
                }

                searchConditionItem.setLabelcol(6);
                if(hrmFieldBean.getFieldname().equals("userid")||hrmFieldBean.getFieldname().equals("jobid")
                        ||hrmFieldBean.getFieldname().equals("subids")
                        ||hrmFieldBean.getFieldname().equals("departmentid")){
                    searchConditionItem.setFieldcol(10);
                }else{
                    searchConditionItem.setFieldcol(18);
                }

                if(!hrmFieldBean.getFieldname().equals("objtype")||!hrmFieldBean.getFieldname().equals("seclevel")){
                    searchConditionItem.setViewAttr(3);
                }
                if(fieldinfo[2].equals("3")){
                    searchConditionItem.getBrowserConditionParam().setViewAttr(3);
                    searchConditionItem.getBrowserConditionParam().setIsSingle(false);
                }

                if(hrmFieldBean.getFieldname().equals("seclevel")){
                    List<Object> value1 = new ArrayList<Object>();
                    value1.add(0);
                    value1.add(100);
                    searchConditionItem.setValue(value1);
                    searchConditionItem.setConditionType(ConditionType.INPUT_INTERVAL);
                }
                itemlist.add(searchConditionItem);
            }

            //下拉 - 类型
            List<Object> condition  = new ArrayList<Object>();
            condition.add(itemlist.get(0));


            Map<String,Object> conditionMap = new HashMap<String, Object>();
            List<Object> conditionlist  = new ArrayList<Object>();
            List<Object> conditionlist2  = new ArrayList<Object>();

            if(tabid == 1) {//接收人类型
                //conditionlist  = new ArrayList<Object>();
                //conditionlist2  = new ArrayList<Object>();
                conditionlist2.add(itemlist.get(11));
                conditionlist.add(conditionlist2);

                conditionMap.put("0",conditionlist);//本部门

                conditionlist  = new ArrayList<Object>();
                conditionlist2  = new ArrayList<Object>();
                conditionlist2.add(itemlist.get(11));
                conditionlist.add(conditionlist2);
                conditionMap.put("1",conditionlist);

                conditionlist  = new ArrayList<Object>();
                conditionlist2  = new ArrayList<Object>();
                conditionlist2.add(itemlist.get(11));
                conditionlist.add(conditionlist2);
                conditionMap.put("2",conditionlist);

                conditionlist  = new ArrayList<Object>();
                conditionlist2  = new ArrayList<Object>();
                conditionlist2.add(itemlist.get(11));
                conditionlist.add(conditionlist2);
                conditionMap.put("3",conditionlist);

                conditionlist  = new ArrayList<Object>();
                conditionlist2  = new ArrayList<Object>();
                conditionlist2.add(itemlist.get(11));
                conditionlist.add(conditionlist2);
                conditionMap.put("4",conditionlist);

                conditionlist  = new ArrayList<Object>();
                conditionlist2  = new ArrayList<Object>();
                conditionlist2.add(itemlist.get(11));
                conditionlist.add(conditionlist2);
                conditionMap.put("5",conditionlist);

                conditionlist  = new ArrayList<Object>();
                conditionlist2  = new ArrayList<Object>();
                conditionlist2.add(itemlist.get(11));
                conditionlist.add(conditionlist2);
                conditionMap.put("6",conditionlist);

                conditionlist  = new ArrayList<Object>();
                conditionlist2  = new ArrayList<Object>();
                conditionlist2.add(itemlist.get(11));
                conditionlist.add(conditionlist2);
                conditionMap.put("7",conditionlist);

                conditionlist  = new ArrayList<Object>();
                conditionlist2  = new ArrayList<Object>();
                conditionlist2.add(itemlist.get(11));
                conditionlist.add(conditionlist2);
                conditionMap.put("8",conditionlist);

                conditionlist  = new ArrayList<Object>();
                conditionlist2  = new ArrayList<Object>();
                conditionlist2.add(itemlist.get(11));
                conditionlist.add(conditionlist2);
                conditionMap.put("9",conditionlist);//所有下级分部
            }

            //指定部门
            conditionlist  = new ArrayList<Object>();
            conditionlist2  = new ArrayList<Object>();
            conditionlist2.add(itemlist.get(3));//部门
            conditionlist.add(conditionlist2);
            conditionlist2  = new ArrayList<Object>();
            conditionlist2.add(itemlist.get(9)); //安全级别
            conditionlist.add(conditionlist2);
            if(!isAdvanceOper){
                conditionlist2  = new ArrayList<Object>();
                conditionlist2.add(itemlist.get(11));//范围关系
                conditionlist.add(conditionlist2);
            }
            conditionMap.put("10",conditionlist);

            //平行部门
            conditionlist  = new ArrayList<Object>();
//            conditionlist2  = new ArrayList<Object>();
//            conditionlist2.add(itemlist.get(3));//部门
//            conditionlist.add(conditionlist2);
            conditionlist2  = new ArrayList<Object>();
            conditionlist2.add(itemlist.get(9)); //安全级别
            conditionlist.add(conditionlist2);
            if(!isAdvanceOper){
                conditionlist2  = new ArrayList<Object>();
                conditionlist2.add(itemlist.get(11));//范围关系
                conditionlist.add(conditionlist2);
            }
            conditionMap.put("16",conditionlist);

            //指定分部
            conditionlist  = new ArrayList<Object>();
            conditionlist2  = new ArrayList<Object>();
            conditionlist2.add(itemlist.get(2));//分部
            conditionlist.add(conditionlist2);
            conditionlist2  = new ArrayList<Object>();
            conditionlist2.add(itemlist.get(9)); //安全级别
            conditionlist.add(conditionlist2);
            if(!isAdvanceOper){
                conditionlist2  = new ArrayList<Object>();
                conditionlist2.add(itemlist.get(11));//范围关系
                conditionlist.add(conditionlist2);
            }
            conditionMap.put("11",conditionlist);

            //指定人员
            conditionlist  = new ArrayList<Object>();
            conditionlist2  = new ArrayList<Object>();
            conditionlist2.add(itemlist.get(1));//人员
            conditionlist.add(conditionlist2);
            if(!isAdvanceOper){
                conditionlist2  = new ArrayList<Object>();
                conditionlist2.add(itemlist.get(11));//范围关系
                conditionlist.add(conditionlist2);
            }
            conditionMap.put("12",conditionlist);

            //指定角色
            conditionlist  = new ArrayList<Object>();
            conditionlist2  = new ArrayList<Object>();
            conditionlist2.add(itemlist.get(4));//角色
            conditionlist.add(conditionlist2);
            conditionlist2  = new ArrayList<Object>();
            conditionlist2.add(itemlist.get(10)); //角色级别
            conditionlist.add(conditionlist2);
            conditionlist2  = new ArrayList<Object>();
            conditionlist2.add(itemlist.get(9)); //安全级别
            conditionlist.add(conditionlist2);
            if(!isAdvanceOper){
                conditionlist2  = new ArrayList<Object>();
                conditionlist2.add(itemlist.get(11));//范围关系
                conditionlist.add(conditionlist2);
            }
            conditionMap.put("13",conditionlist);

            //指定岗位
            conditionlist  = new ArrayList<Object>();
            conditionlist2  = new ArrayList<Object>();
            conditionlist2.add(itemlist.get(5));//岗位
            conditionlist.add(conditionlist2);
            conditionlist2  = new ArrayList<Object>();
            conditionlist2.add(itemlist.get(6)); //岗位级别
            WeaRadioGroup wrg = new WeaRadioGroup();
            wrg.setLabel(SystemEnv.getHtmlLabelName(28169, user.getLanguage()));
            List<Object> option = new ArrayList<Object>();
            Map<String, Object> selectLinkageDatas = new HashMap<String, Object>();
            selectLinkageDatas.put("0" ,itemlist.get(8));
            selectLinkageDatas.put("1" ,itemlist.get(7));
            wrg.setSelectLinkageDatas(selectLinkageDatas);

            conditionlist2  = new ArrayList<Object>();
            option.add(new SelectOption("2", SystemEnv.getHtmlLabelName(140, user.getLanguage()),true));
            option.add(new SelectOption("0", SystemEnv.getHtmlLabelName(19438, user.getLanguage())));
            option.add(new SelectOption("1", SystemEnv.getHtmlLabelName(19437, user.getLanguage())));

            List<String>  domkey =  new  ArrayList<String>();
            wrg.setOptions(option);
            wrg.setConditionType("SELECT_LINKAGE");
            wrg.setFieldcol(18);
            wrg.setLabelcol(6);
            domkey.add("joblevel");
            wrg.setDomkey(domkey);

            conditionlist2  = new ArrayList<Object>();
            conditionlist2.add(wrg);
            conditionlist.add(conditionlist2);

            if(!isAdvanceOper){
                conditionlist2  = new ArrayList<Object>();
                conditionlist2.add(itemlist.get(11));//范围关系
                conditionlist.add(conditionlist2);
            }
            conditionMap.put("14",conditionlist);

            //所有人
            if(!new ManageDetachComInfo().appDetachDisableAll(user)){
                conditionlist  = new ArrayList<Object>();
                conditionlist2  = new ArrayList<Object>();
                conditionlist2.add(itemlist.get(9)); //安全级别
                conditionlist.add(conditionlist2);
            }

            if(!isAdvanceOper){
                conditionlist2  = new ArrayList<Object>();
                conditionlist2.add(itemlist.get(11));//范围关系
                conditionlist.add(conditionlist2);
            }
            conditionMap.put("15",conditionlist);

            condition.add(conditionMap);
            apidatas.put("conditions", condition);
            apidatas.put("hidden",hiddenMap);
            apidatas.put("success", "1");
        }catch (Exception e){
            e.printStackTrace();
            apidatas.put("success", "0");
            apidatas.put("msg", ""+ SystemEnv.getHtmlLabelName(126400,weaver.general.ThreadVarLanguage.getLang())+"");
        }
        return apidatas;
    }

    /**
     * 类型选项
     * @param user
     * @param tabid
     * @return
     */
    public List<SearchConditionOption> getObjTypeOption(User user, int tabid){
        List<SearchConditionOption> options = new ArrayList<SearchConditionOption>();

        if(tabid == 1){//接收人类型
            options.add(new SearchConditionOption("0", SystemEnv.getHtmlLabelName(21837,user.getLanguage()),true));//本部门
            options.add(new SearchConditionOption("1", SystemEnv.getHtmlLabelName(386081,user.getLanguage()),false));//直接上级部门
            options.add(new SearchConditionOption("2", SystemEnv.getHtmlLabelName(386082,user.getLanguage()),false));//所有上级部门
            options.add(new SearchConditionOption("3", SystemEnv.getHtmlLabelName(17587,user.getLanguage()),false));//下级部门
            options.add(new SearchConditionOption("4", SystemEnv.getHtmlLabelName(386083,user.getLanguage()),false));//所有下级部门
            options.add(new SearchConditionOption("5", SystemEnv.getHtmlLabelName(30792,user.getLanguage()),false));//本分部
            options.add(new SearchConditionOption("6", SystemEnv.getHtmlLabelName(386084,user.getLanguage()),false));//直接上级分部
            options.add(new SearchConditionOption("7", SystemEnv.getHtmlLabelName(386085,user.getLanguage()),false));//所有上级分部
            options.add(new SearchConditionOption("8", SystemEnv.getHtmlLabelName(17898,user.getLanguage()),false));//下级分部
            options.add(new SearchConditionOption("9", SystemEnv.getHtmlLabelName(386086,user.getLanguage()),false));//所有下级分部
        }
        if(tabid==1){ //接收人类型
            options.add(new SearchConditionOption("10", SystemEnv.getHtmlLabelName(19438,user.getLanguage()),false));//指定部门
            options.add(new SearchConditionOption("16", SystemEnv.getHtmlLabelName(10006035,user.getLanguage()),false));//平行部门
        }else {//操作者类型
            options.add(new SearchConditionOption("10", SystemEnv.getHtmlLabelName(19438,user.getLanguage()),true));//指定部门
            options.add(new SearchConditionOption("16", SystemEnv.getHtmlLabelName(10006035,user.getLanguage()),true));//平行部门
        }
        options.add(new SearchConditionOption("11", SystemEnv.getHtmlLabelName(19437,user.getLanguage()),false));//指定分部
        options.add(new SearchConditionOption("12", SystemEnv.getHtmlLabelName(81811,user.getLanguage()),false));//指定人员
        options.add(new SearchConditionOption("13", SystemEnv.getHtmlLabelName(382788,user.getLanguage()),false));//指定角色
        options.add(new SearchConditionOption("14", SystemEnv.getHtmlLabelName(382789,user.getLanguage()),false));//指定岗位
        if(!new ManageDetachComInfo().appDetachDisableAll(user)) {
            options.add(new SearchConditionOption("15", SystemEnv.getHtmlLabelName(1340, user.getLanguage()), false));//所有人
        }
        return options;
    }

}
